<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iCelGameClient Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iCelGameClient Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iCelGameClient" --><!-- doxytag: inherits="iBase" -->
<p>The main object to manage the client game logic.  
 <a href="structiCelGameClient.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="network_8h_source.html">physicallayer/network.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iCelGameClient:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiCelGameClient.png" usemap="#iCelGameClient_map" alt=""/>
  <map id="iCelGameClient_map" name="iCelGameClient_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,98,24"/>
</map>
 </div></div>

<p><a href="structiCelGameClient-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameClient.html#aca67c50f3709d839171e405a31aa8918">ConvertServerClock</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> server_time) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert a time from the server clock to the client clock.  <a href="#aca67c50f3709d839171e405a31aa8918"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structiCelEntity.html">iCelEntity</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameClient.html#a34d610d547dfa9cea731f808d017145e">GetMappedEntity</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga91ad9478d81a7aaf2593e8d9c3d06a14">uint</a> entity_id) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the entity on the client side that is network linked with an entity with ID entity_id on the server side.  <a href="#a34d610d547dfa9cea731f808d017145e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga91ad9478d81a7aaf2593e8d9c3d06a14">uint</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameClient.html#ab1174ab40fc358ddcf9f2ae6099df749">GetMappedID</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga91ad9478d81a7aaf2593e8d9c3d06a14">uint</a> entity_id) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the ID of the entity on the client side that is network linked with an entity with ID entity_id on the server side.  <a href="#ab1174ab40fc358ddcf9f2ae6099df749"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameClient.html#a9f7e81fb02d8477658d040988c913770">GetNetworkStats</a> (<a class="el" href="structcelNetworkServerStats.html">celNetworkServerStats</a> &amp;stats) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the network stats of this client.  <a href="#a9f7e81fb02d8477658d040988c913770"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classcelPlayer.html">celPlayer</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameClient.html#a53e07ebfff959587f343f488306bceda">GetPlayer</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the current player associated with this client.  <a href="#a53e07ebfff959587f343f488306bceda"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameClient.html#a5b931754075fb1eae48e6cbc4ef5cbd0">LaunchClientEvent</a> (<a class="el" href="classcelClientEventData.html">celClientEventData</a> &amp;event_data)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Ask the game client to send an event to the server.  <a href="#a5b931754075fb1eae48e6cbc4ef5cbd0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameClient.html#ac711d59e3017062fe6524664eb608290">RegisterClientManager</a> (<a class="el" href="classcelGameClientManager.html">celGameClientManager</a> *manager)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Register the manager of this client.  <a href="#ac711d59e3017062fe6524664eb608290"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameClient.html#a1dabc15bda68c4ce7b34466abfa8a327">SetMaximumBandwidth</a> (size_t width)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The maximum bandwidth of the network data transmission in bytes per second.  <a href="#a1dabc15bda68c4ce7b34466abfa8a327"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameClient.html#acbca219321e1c5d3293917dd4f1c50e1">SetNetworkPeriod</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> period)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Specify the maximum frequency at which the client can send data.  <a href="#acbca219321e1c5d3293917dd4f1c50e1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameClient.html#abbd38fbb4892af3680c5a78ed67204c3">SetReady</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Indicate that the client has loaded everything and is ready to play.  <a href="#abbd38fbb4892af3680c5a78ed67204c3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameClient.html#aedceff04188a52a3cc1290a985f4bc88">SetServerTimeOut</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> timeout)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The client will consider itself connected to the server until the connection is broken during specified time.  <a href="#aedceff04188a52a3cc1290a985f4bc88"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameClient.html#a89bc1a1269e364572b58d434b90a2ecd">UpdatePlayer</a> (<a class="el" href="classcelPlayer.html">celPlayer</a> *player)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Update the data of the current player.  <a href="#a89bc1a1269e364572b58d434b90a2ecd"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>The main object to manage the client game logic. </p>
<p>You can use it to:</p>
<ul>
<li>update the data of the player.</li>
<li>convert a server clock or a server entity ID in client values.</li>
<li>tell the system when the player is ready to play.</li>
<li>send client events.</li>
<li>set some options on the client.</li>
<li>get some network statistics.</li>
</ul>
<p>You should define and register a <a class="el" href="classcelGameClientManager.html" title="This is an interface you should implement in order to manage the events from the client.">celGameClientManager</a> which will catch the events from this client. </p>

<p>Definition at line <a class="el" href="network_8h_source.html#l00512">512</a> of file <a class="el" href="network_8h_source.html">network.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="aca67c50f3709d839171e405a31aa8918"></a><!-- doxytag: member="iCelGameClient::ConvertServerClock" ref="aca67c50f3709d839171e405a31aa8918" args="(csTicks server_time) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> <a class="el" href="structiCelGameClient.html#aca67c50f3709d839171e405a31aa8918">iCelGameClient::ConvertServerClock</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a>&#160;</td>
          <td class="paramname"><em>server_time</em></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Convert a time from the server clock to the client clock. </p>

</div>
</div>
<a class="anchor" id="a34d610d547dfa9cea731f808d017145e"></a><!-- doxytag: member="iCelGameClient::GetMappedEntity" ref="a34d610d547dfa9cea731f808d017145e" args="(uint entity_id) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structiCelEntity.html">iCelEntity</a>* <a class="el" href="structiCelGameClient.html#a34d610d547dfa9cea731f808d017145e">iCelGameClient::GetMappedEntity</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga91ad9478d81a7aaf2593e8d9c3d06a14">uint</a>&#160;</td>
          <td class="paramname"><em>entity_id</em></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the entity on the client side that is network linked with an entity with ID entity_id on the server side. </p>

</div>
</div>
<a class="anchor" id="ab1174ab40fc358ddcf9f2ae6099df749"></a><!-- doxytag: member="iCelGameClient::GetMappedID" ref="ab1174ab40fc358ddcf9f2ae6099df749" args="(uint entity_id) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga91ad9478d81a7aaf2593e8d9c3d06a14">uint</a> <a class="el" href="structiCelGameClient.html#ab1174ab40fc358ddcf9f2ae6099df749">iCelGameClient::GetMappedID</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga91ad9478d81a7aaf2593e8d9c3d06a14">uint</a>&#160;</td>
          <td class="paramname"><em>entity_id</em></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the ID of the entity on the client side that is network linked with an entity with ID entity_id on the server side. </p>

</div>
</div>
<a class="anchor" id="a9f7e81fb02d8477658d040988c913770"></a><!-- doxytag: member="iCelGameClient::GetNetworkStats" ref="a9f7e81fb02d8477658d040988c913770" args="(celNetworkServerStats &amp;stats) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameClient.html#a9f7e81fb02d8477658d040988c913770">iCelGameClient::GetNetworkStats</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structcelNetworkServerStats.html">celNetworkServerStats</a> &amp;&#160;</td>
          <td class="paramname"><em>stats</em></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the network stats of this client. </p>

</div>
</div>
<a class="anchor" id="a53e07ebfff959587f343f488306bceda"></a><!-- doxytag: member="iCelGameClient::GetPlayer" ref="a53e07ebfff959587f343f488306bceda" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classcelPlayer.html">celPlayer</a>* <a class="el" href="structiCelGameClient.html#a53e07ebfff959587f343f488306bceda">iCelGameClient::GetPlayer</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the current player associated with this client. </p>

</div>
</div>
<a class="anchor" id="a5b931754075fb1eae48e6cbc4ef5cbd0"></a><!-- doxytag: member="iCelGameClient::LaunchClientEvent" ref="a5b931754075fb1eae48e6cbc4ef5cbd0" args="(celClientEventData &amp;event_data)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameClient.html#a5b931754075fb1eae48e6cbc4ef5cbd0">iCelGameClient::LaunchClientEvent</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelClientEventData.html">celClientEventData</a> &amp;&#160;</td>
          <td class="paramname"><em>event_data</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Ask the game client to send an event to the server. </p>

</div>
</div>
<a class="anchor" id="ac711d59e3017062fe6524664eb608290"></a><!-- doxytag: member="iCelGameClient::RegisterClientManager" ref="ac711d59e3017062fe6524664eb608290" args="(celGameClientManager *manager)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameClient.html#ac711d59e3017062fe6524664eb608290">iCelGameClient::RegisterClientManager</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelGameClientManager.html">celGameClientManager</a> *&#160;</td>
          <td class="paramname"><em>manager</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Register the manager of this client. </p>
<p>Only one manager can be registered at a time. </p>

</div>
</div>
<a class="anchor" id="a1dabc15bda68c4ce7b34466abfa8a327"></a><!-- doxytag: member="iCelGameClient::SetMaximumBandwidth" ref="a1dabc15bda68c4ce7b34466abfa8a327" args="(size_t width)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameClient.html#a1dabc15bda68c4ce7b34466abfa8a327">iCelGameClient::SetMaximumBandwidth</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>width</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The maximum bandwidth of the network data transmission in bytes per second. </p>
<p>A bandwidth of 0 means that it is unlimited. </p>

</div>
</div>
<a class="anchor" id="acbca219321e1c5d3293917dd4f1c50e1"></a><!-- doxytag: member="iCelGameClient::SetNetworkPeriod" ref="acbca219321e1c5d3293917dd4f1c50e1" args="(csTicks period)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameClient.html#acbca219321e1c5d3293917dd4f1c50e1">iCelGameClient::SetNetworkPeriod</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a>&#160;</td>
          <td class="paramname"><em>period</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Specify the maximum frequency at which the client can send data. </p>

</div>
</div>
<a class="anchor" id="abbd38fbb4892af3680c5a78ed67204c3"></a><!-- doxytag: member="iCelGameClient::SetReady" ref="abbd38fbb4892af3680c5a78ed67204c3" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameClient.html#abbd38fbb4892af3680c5a78ed67204c3">iCelGameClient::SetReady</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Indicate that the client has loaded everything and is ready to play. </p>

</div>
</div>
<a class="anchor" id="aedceff04188a52a3cc1290a985f4bc88"></a><!-- doxytag: member="iCelGameClient::SetServerTimeOut" ref="aedceff04188a52a3cc1290a985f4bc88" args="(csTicks timeout)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameClient.html#aedceff04188a52a3cc1290a985f4bc88">iCelGameClient::SetServerTimeOut</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a>&#160;</td>
          <td class="paramname"><em>timeout</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The client will consider itself connected to the server until the connection is broken during specified time. </p>

</div>
</div>
<a class="anchor" id="a89bc1a1269e364572b58d434b90a2ecd"></a><!-- doxytag: member="iCelGameClient::UpdatePlayer" ref="a89bc1a1269e364572b58d434b90a2ecd" args="(celPlayer *player)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameClient.html#a89bc1a1269e364572b58d434b90a2ecd">iCelGameClient::UpdatePlayer</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelPlayer.html">celPlayer</a> *&#160;</td>
          <td class="paramname"><em>player</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Update the data of the current player. </p>
<p>The server will check if the new data are valid and a subsequent celGameClientManager::PlayerUpdated will be called with the validated data. </p>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>physicallayer/<a class="el" href="network_8h_source.html">network.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
